//---------------------------------------------------------------------------

#include <vcl.h>
#include "ITSSkinF.h"
#include "ITSUtilF.h"
#include "AppGlobalF.h"
#include "ITSLangTransF.h"
#pragma hdrstop

#include "TAS0030MF.h"
#include "TAS00301F.h"
#include "CDSCodeF.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "cxButtons"
#pragma link "cxContainer"
#pragma link "cxControls"
#pragma link "cxDropDownEdit"
#pragma link "cxEdit"
#pragma link "cxGraphics"
#pragma link "cxGroupBox"
#pragma link "cxLookAndFeelPainters"
#pragma link "cxLookAndFeels"
#pragma link "cxMaskEdit"
#pragma link "cxPC"
#pragma link "cxPCdxBarPopupMenu"
#pragma link "cxTextEdit"
#pragma link "dxSkinBlack"
#pragma link "dxSkinBlue"
#pragma link "dxSkinsCore"
#pragma link "dxSkinscxPCPainter"
#pragma resource "*.dfm"

TTAS0030M *TAS0030M = NULL;
//---------------------------------------------------------------------------
__fastcall TTAS0030M::TTAS0030M(TComponent* Owner)
    : TForm(Owner)
{
    LangTrans->Translate(this, ITSDb_GetConnection());
    ITSSkin_Load(this);
    CMM_LoadForm(g_sFormsDir, this);

    FTitle = Caption;//"노선별속도분석";
    m_pFormList = new TList(); 
    TsList01->TabVisible = false;

    MyItsAtrdManager = new TItsAtrdManager();
    MyItsAtrdManager->LoadFromDb();
}
//---------------------------------------------------------------------------

void __fastcall TTAS0030M::CommClose()
{
    try
    {
        if (MyItsAtrdManager)
        {
            delete MyItsAtrdManager;
            MyItsAtrdManager = NULL;
        }

        for (int idx = m_pFormList->Count-1; idx >= 0; idx--)
        {
            m_pFormList->Delete(idx);
        }
        delete m_pFormList;

        CMM_SaveForm(g_sFormsDir, this);
    }
    catch(...)
    {
    }
}
//---------------------------------------------------------------------------

void __fastcall TTAS0030M::FormShow(TObject *Sender)
{
    Refresh();
    FormInit();
    TmrShow->Enabled = true;
}
//---------------------------------------------------------------------------

void __fastcall TTAS0030M::FormInit()
{
    CbAtrd->Properties->Items->Clear();
    try
    {
        MyItsAtrdManager->FNameLists.Lock();
        FOR_STL(TItsAtrdName*, pObj, MyItsAtrdManager->FNameLists)
        {
            CbAtrd->Properties->Items->AddObject(pObj->Name, (TObject*)pObj);
        }
    }
    __finally
    {
        MyItsAtrdManager->FNameLists.UnLock();
        CbAtrd->ItemIndex = 0;
    }
#if 0
    try
    {
        MyItsAtrdManager->FLists.Lock();
        FOR_STL(TItsAtrd*, pObj, MyItsAtrdManager->FLists)
        {
            if (pObj->DEL_YN == "Y") continue;

            String sDir = (pObj->DRCT_CD.Trim() == "0") ? FrmLang->lblUp->Caption : FrmLang->lblDown->Caption;String("상행") : String("하행");
            String sAtr = pObj->ATRD_NM;
            CbAtrd->Properties->Items->AddObject(sAtr + " [" + sDir + "]", (TObject*)pObj);
        }
    }
    __finally
    {
        MyItsAtrdManager->FLists.UnLock();

        CbAtrd->ItemIndex = 0;
    }
#endif

    DtDay->Date = IncHour(Now(), -24);
}
//---------------------------------------------------------------------------

void __fastcall TTAS0030M::TmrShowTimer(TObject *Sender)
{
    TmrShow->Enabled = false;
}
//---------------------------------------------------------------------------

void __fastcall TTAS0030M::RefreshData()
{
    // 검색조건에 의한 링크 데이터 조회
    try
    {
        //SelListData();
	}
	__finally
	{
	}
}
//---------------------------------------------------------------------------

void __fastcall TTAS0030M::BtnSearchClick(TObject *Sender)
{
    Application->ProcessMessages();
    TSqlCursor sqlCrs((TControl*)BtnSearch);

    String sTitle;

	FQryDay = DtDay->Date.FormatString("yyyymmdd");
    FAtrdId = CbAtrd->Text.Trim();
    FAtrdNm = CbAtrd->Text.Trim();
#if 0
    if (CbAtrd->ItemIndex == 0)
    {
        FAtrdId = "";
        FAtrdNm = FrmLang->lblChartTotal->Caption;//"전체";
    }
#endif

	sTitle.printf(L"%s %s  ", FQryDay.c_str(), FAtrdNm.c_str());

    try
    {
        Application->ProcessMessages();
        LockWindowUpdate(Handle);

        TcxTabSheet *pSheet = CMM_AddTabSheet(PgTab, sTitle);
        if (!pSheet) return;

        TAS00301 = new TTAS00301(this, Handle, FAtrdId, FAtrdNm, FQryDay, FPtrnWeek, FPtrnWeekName);
        TAS00301->Parent = pSheet;
        TAS00301->Show();
        PgTab->ActivePage = pSheet;
        pSheet = PgTab->ActivePage;
        m_pFormList->Add(TAS00301);
    }
    __finally
    {
        LockWindowUpdate(0);
    }
}
//---------------------------------------------------------------------------

void __fastcall TTAS0030M::BtnCloseClick(TObject *Sender)
{
    Close();    
}
//---------------------------------------------------------------------------

void __fastcall TTAS0030M::OnSubFormClose(TMessage Msg)
{
    int nActiveIdx = PgTab->ActivePageIndex;
    if (nActiveIdx <= 0) return;

    LockWindowUpdate(Handle);

    TcxTabSheet *pSheet = PgTab->ActivePage;
    if (pSheet)
    {
        delete pSheet;
    }
    nActiveIdx--;   // 첫번째 탭은 화면에 숨겨져 있다.
    m_pFormList->Delete(nActiveIdx);

    LockWindowUpdate(0);
}
//---------------------------------------------------------------------------

void __fastcall TTAS0030M::PgTabDblClick(TObject *Sender)
{
    TPoint APoint;
    APoint = PgTab->MouseDownPos;
    if (PgTab->IndexOfTabAt(APoint.x, APoint.y) != -1)
        POST_MSG(Handle, WM_SUBFORM_CLOSE, 0, 0);
}
//---------------------------------------------------------------------------

void __fastcall TTAS0030M::FormClose(TObject *Sender, TCloseAction &Action)
{
    CommClose();
    TAS0030M = NULL;
    Action = caFree;    
}
//---------------------------------------------------------------------------

void __fastcall TTAS0030M::PgTabCanCloseEx(TObject *Sender, int ATabIndex, bool &ACanClose)
{
    int nActiveIdx = ATabIndex;
    if (nActiveIdx <= 0) return;

    nActiveIdx--;   // 첫번째 탭은 화면에 숨겨져 있다.
    m_pFormList->Delete(nActiveIdx);
}
//---------------------------------------------------------------------------

